import { renderless, api } from '@opentinyvue/vue-renderless/dynamic-scroller/vue';
import { defineComponent, props, setup, emitter } from '@opentinyvue/vue-common';
import RecycleScroller from '@opentinyvue/vue-recycle-scroller';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  inheritAttrs: false,
  emits: ["resize", "visible"],
  props: [].concat(props, ["items", "keyField", "direction", "listTag", "itemTag", "minItemSize"]),
  components: {
    TinyRecycleScroller: RecycleScroller
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      extendOptions: {
        emitter
      }
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("tiny-recycle-scroller", _vm._b({
    ref: "scroller",
    staticClass: "tiny-dynamic-scroller",
    attrs: {
      "items": _vm.state.itemsWithSize,
      "min-item-size": _vm.minItemSize,
      "direction": _vm.direction,
      "key-field": _vm.keyField,
      "list-tag": _vm.listTag,
      "item-tag": _vm.itemTag
    },
    on: {
      "resize": _vm.onScrollerResize,
      "visible": _vm.onScrollerVisible
    },
    scopedSlots: _vm._u([{
      key: "default",
      fn: function fn(_ref) {
        var itemWithSize = _ref.item, index = _ref.index, active = _ref.active;
        return [_vm._t("default", null, null, {
          item: itemWithSize.item,
          index,
          active,
          itemWithSize
        })];
      }
    }, {
      key: "before",
      fn: function fn() {
        return [_vm._t("before")];
      },
      proxy: true
    }, {
      key: "after",
      fn: function fn() {
        return [_vm._t("after")];
      },
      proxy: true
    }, {
      key: "empty",
      fn: function fn() {
        return [_vm._t("empty")];
      },
      proxy: true
    }], null, true)
  }, "tiny-recycle-scroller", _vm.$attrs, false));
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
